#line 1 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for 8051/projetos_Mikro_8051/Termometer_ds18b20_89c2051/Termometer_ds18b20_At89c2051.c"
#line 24 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for 8051/projetos_Mikro_8051/Termometer_ds18b20_89c2051/Termometer_ds18b20_At89c2051.c"
sbit a3 at P1.B3;
sbit a2 at P1.B4;
sbit a1 at P1.B5;
sbit a0 at P1.B6;
sbit OW_Bit at P1_0_bit;


char pv,un,dez,cent,vez;
unsigned int temp;
bit f_neg;


const unsigned short TEMP_RESOLUTION = 12;


const char num[]= {
 0b11000000,
 0b11111001,
 0b01100100,
 0b01110000,
 0b01011001,
 0b01010010,
 0b01000010,
 0b11111000,
 0b01000000,
 0b01010000,
 0b01111111,
};
#line 57 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for 8051/projetos_Mikro_8051/Termometer_ds18b20_89c2051/Termometer_ds18b20_At89c2051.c"
void multiplexa(){
 a3=1;
 a2=1;
 a1=1;
 a0=1;
 if(++vez>3)vez=0;
 if(vez==0){P3=pv; a0=0;}
 if(vez==1){P3=un; a1=0;}
 if(vez==2){P3=dez; a2=0;}
 if(vez==3){P3=cent; a3=0;}

}
#line 72 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for 8051/projetos_Mikro_8051/Termometer_ds18b20_89c2051/Termometer_ds18b20_At89c2051.c"
void delay_mpx( char valor){
 char d;
 for(d=0;d<valor;d++){
 multiplexa();
 delay_ms(1);
 }
}
#line 83 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for 8051/projetos_Mikro_8051/Termometer_ds18b20_89c2051/Termometer_ds18b20_At89c2051.c"
void Mostra_Temp(unsigned int temp_lida) {
 const unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
 char temp_int;
 unsigned int temp_fraction;


 if (temp_lida & 0x8000) {
 f_neg = 1;
 temp_lida = ~temp_lida + 1;
 }

 temp_int = temp_lida >> RES_SHIFT;
 cent=0;
 while(temp_int>=100){temp_int= temp_int - 100; cent++;}
 dez=0;
 while(temp_int>=10){temp_int= temp_int - 10; dez++;};
 un=temp_int;


 temp_fraction = temp_lida << (4-RES_SHIFT);
 temp_fraction &= 0x000F;
 temp_fraction *= 625;
 pv=0;
 while(temp_fraction>=1000){
 temp_fraction= temp_fraction - 1000;
 pv++;
 }

 cent=num[cent];
 if(cent== 0xc0)cent=0xff;
 dez=num[dez];
 if(cent==0xff && dez==0xc0)dez=0xff;
 un=num[un];
 pv=num[pv];
 if(f_neg){f_neg=0; cent=num[10];}
}
#line 123 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for 8051/projetos_Mikro_8051/Termometer_ds18b20_89c2051/Termometer_ds18b20_At89c2051.c"
void main() {
 P1=0b00111011;
 P3=0xff;
 vez=0;
 f_neg=0;
#line 132 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for 8051/projetos_Mikro_8051/Termometer_ds18b20_89c2051/Termometer_ds18b20_At89c2051.c"
 for(;;){
 Ow_Reset();
 multiplexa();
 Ow_Write(0xCC);
 multiplexa();
 Ow_Write(0x44);
 delay_mpx(120);

 Ow_Reset();
 multiplexa();
 Ow_Write(0xCC);
 multiplexa();
 Ow_Write(0xBE);

 temp = Ow_Read();
 multiplexa();
 temp = (Ow_Read() << 8) + temp;
 multiplexa();


 Mostra_Temp(temp);
 delay_mpx(500);
 }
}
